; Stkdemo2.asm ========================================================
;
;	Title: STKDEMO2.ASM
;	Author: B. Smith
;	Date: July 2, 1996
;
;	This program demonstrates subroutines and stack functions
;	Consider the following....
;
;	1. a time delay is needed in many parts of the program	
;	
;	2. 
;	
;
;
;
;
;


; :Equates ----------------------------------------------------------

.equ	DELAY1ms,	h'00
.equ	DELAY10ms,	h'00
.equ	LEDS_ON,	h'ce
.equ	LEDS_OFF,	h'cf

; :MAIN ==========================================================
;
;	Reg A	Light pattern
;	

.org h'4000

;-----------------------------------------------------------------
; flash LEDs at a rate of 1 Hz

	mvi a, h'ff
	out LEDS_OFF
	
	call S_DELAY

	mvi a, h'ff
	out LEDS_ON

	call S_DELAY

	mvi a, h'ff
	out LEDS_OFF

;-----------------------------------------------------------------
;	
;

	mvi a, h'01
MAIN_LP:
	out LEDS_ON	
	call S_Delay	; wait 500ms
	out LEDS_OFF
	rlc
	jmp MAIN_LP


;=================================================================
; END of the MAIN PROGRAM ========================================



;-----------------------------------------------------------------
;  Subroutines ---------------------------------------------------
;-----------------------------------------------------------------

; :S_Alarm ---------------------------------------------------------
; change pattern on LEDs to indicate process is finished

S_Alarm:
	push 	psw
	mvi 	a, h'ff		;turn off all LEDs
	out 	LEDS_OFF
	mvi 	a, h'aa		; LED Pattern 1010 1010
	out 	LEDS_ON
	pop 	psw
	ret

;:ENDOF S_Alarm------------------------------------------------------

;:S_Delay ---------------------------------------------------------
;                      Time Delay
;
;	This is a fixed time delay of 500ms 
; 	
;	Registers affected:
; 		Acc	: temp storage
;		Reg BC	: count for delay time
;

S_Delay:
		push psw	; preserve registers affected by this subroutine
		push b
		lxi b,h'7a11    ;0x7a11 = 500ms delay

; :TODO -- check the value placed in Reg BC (correct?)

Del_Loop:	
		nop
		nop
		dcx b		; DCX does not affect flags
		mov a,b 
		ora c
		jnz Del_Loop
		pop b		; restore the registers
		pop psw
		ret

;: ENDOF S_Delay -------------------------------------------------------
.end	